# Frappe 教程

在本指南中，我们将向您展示如何使用 **Frappe** 从头开始创建一个应用。 以图书馆管理系统为例，我们将涵盖：

1. 安装
2. 制作新的应用
3. 制作模块
4. 创建用户和记录
5. 创建控制器
6. 创建 Web 视图
7. 配置钩子和任务

## 这是给谁的？

本指南适用于熟悉 Web 应用生成和维护的软件开发人员。 Frappe 框架是建立在 Python 上，并使用 MariaDB 数据库以及 HTML/CSS/Javascript 创建 Web 视图。 如果您熟悉所有这些技术将会非常有帮助。 如果您以前从未使用过 Python，则在使用本指南之前，至少应先阅读快速教程。

Frappe 在 GitHub 上使用 git 版本控制系统。 您熟悉基本的 git 操作，并在 GitHub 上有一个帐户来管理您的应用也同样重要。

## 示例

在本指南中，我们将构建一个简单的 **图书馆管理** 应用。 在这个应用中，我们将有如下模型：

1. 物品 (可以借出的图书或任何其他物品)
2. 图书馆用户
3. 图书馆交易 (借出或归物品)
4. 图书馆会籍 (允许会员交易期间)
5. 图书馆管理设置 (如借出期限的全局设置)

图书管理员的用户界面（UI）将会是 **Frappe 桌面**，一个内置的根据模型、角色和权限自动生成的基于浏览器的 UI 环境。

我们还将为图书馆创建 Web 视图，用户可以从网站浏览物品。

{index}